package com.landray.kmss.sys.attachment.jg;

import org.hibernate.engine.jdbc.NonContextualLobCreator;
import com.landray.kmss.util.SpringBeanUtil;
import com.landray.kmss.sys.attachment.service.ISysAttMainCoreInnerService;
import java.util.Date;
import com.landray.kmss.util.FileMimeTypeUtil;
import com.landray.kmss.sys.attachment.model.SysAttRtfData;
import com.landray.kmss.util.StringUtil;
import DBstep.iMsgServer2000;
import com.landray.kmss.common.actions.RequestContext;
import org.slf4j.LoggerFactory;
import org.slf4j.Logger;

public class SysAttJGPutFileFunction implements ISysAttachmentJGFunction
{
    private static final Logger logger;
    
    static {
        logger = LoggerFactory.getLogger(SysAttJGPutFileFunction.class);
    }
    
    @Override
    public void execute(final RequestContext request, final iMsgServer2000 MsgObj) throws Exception {
        final String modelId = MsgObj.GetMsgByName("RECORDID");
        final String type = MsgObj.GetMsgByName("upload_type");
        if (StringUtil.isNotNull(type) && "rtf".equals(type)) {
            try {
                final String fileName = MsgObj.GetMsgByName("rtf_file_name");
                final SysAttRtfData sysAttRtfData = new SysAttRtfData();
                sysAttRtfData.setFdFileName(fileName);
                sysAttRtfData.setFdContentType(FileMimeTypeUtil.getContentType(fileName));
                sysAttRtfData.setDocCreateTime(new Date());
                sysAttRtfData.setFdSize(new Double(MsgObj.MsgFileSize()));
                final ISysAttMainCoreInnerService sysAttMainService = (ISysAttMainCoreInnerService)SpringBeanUtil.getBean("sysAttMainService");
                final String fdId = sysAttMainService.addRtfData(sysAttRtfData, NonContextualLobCreator.INSTANCE.createBlob(MsgObj.MsgFileBody()).getBinaryStream());
                final String fileUrl = String.valueOf(request.getContextPath()) + "/resource/fckeditor/editor/filemanager/download" + "?fdId=" + fdId.toString();
                MsgObj.SetMsgByName("STATUS", "上传文件成功!");
                MsgObj.SetMsgByName("fileUrl", fileUrl);
                MsgObj.MsgError("");
            }
            catch (final Exception ex) {
                MsgObj.MsgError("上传文件失败!");
            }
        }
        else {
            final String mFilePath = String.valueOf(JGFilePathUtil.genFilePath(modelId, "JG_Document")) + MsgObj.GetMsgByName("REMOTEFILE");
            if (SysAttJGPutFileFunction.logger.isDebugEnabled()) {
                SysAttJGPutFileFunction.logger.debug("上传文件：文件目录路径：" + mFilePath);
            }
            if (MsgObj.MsgFileSave(mFilePath)) {
                MsgObj.SetMsgByName("STATUS", "上传文件成功!");
                MsgObj.MsgError("");
            }
            else {
                MsgObj.MsgError("上传文件失败!");
            }
            MsgObj.MsgTextClear();
        }
    }
}
